<template>
  <div class="-grid-2 -gap">
    <!-- No need for rui-form here -->
    <form action="#" @submit.prevent="()=>{}">
      <rui-field input-id="soil-analyser-clay"
                 :label="$t('js.widgets.soil_analyzer.clay', { value: inputs.clay })"
                 :append="`${round(clayPercent)}%`">
        <input id="soil-analyser-clay"
               v-model="inputs.clay"
               type="number"
               min="0"
               step="0.1"
               name="clay">
      </rui-field>

      <rui-field input-id="soil-analyser-silt"
                 :label="$t('js.widgets.soil_analyzer.silt', { value: inputs.silt })"
                 :append="`${round(siltPercent)}%`">
        <input id="soil-analyser-silt"
               v-model="inputs.silt"
               type="number"
               min="0"
               step="0.1"
               name="silt">
      </rui-field>

      <rui-field input-id="soil-analyser-sand"
                 :label="$t('js.widgets.soil_analyzer.sand', { value: inputs.sand })"
                 :append="`${round(sandPercent)}%`">
        <input id="soil-analyser-sand"
               v-model="inputs.sand"
               type="number"
               min="0"
               step="0.1"
               name="sand">
      </rui-field>
    </form>
    <aside>
      <soil-analyzer :clay="clayValue"
                     :silt="siltValue"
                     :sand="sandValue"
                     :show-legend="true" />
    </aside>
  </div>
</template>

<script>
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import SoilAnalyzer from '../../../../common/DataDisplay/SoilAnalyzer/SoilAnalyzer.vue'

export default {
  name: 'SoilAnalysis',
  components: { RuiField, SoilAnalyzer },
  data () {
    return {
      inputs: {
        clay: 0,
        silt: 0,
        sand: 0,
      },
    }
  },
  computed: {
    clayPercent () { return this.total === 0 ? 0 : this.clayValue / this.total * 100 },
    siltPercent () { return this.total === 0 ? 0 : this.siltValue / this.total * 100 },
    sandPercent () { return this.total === 0 ? 0 : this.sandValue / this.total * 100 },
    clayValue () { return parseFloat(this.inputs.clay) },
    siltValue () { return parseFloat(this.inputs.silt) },
    sandValue () { return parseFloat(this.inputs.sand) },
    total () { return this.clayValue + this.siltValue + this.sandValue },
  },
  methods: {
    round (value) { return Math.round(value) },
  },
}
</script>
